#include <iostream>
#include <vector>
#include <queue>
#include <algorithm>
#include <climits>
#include <set>
#define VMAX 1000000000
using namespace std;

struct Movie {
    int start, end;
};
int N, K, T;
vector<Movie> movies;

bool check(int nrPersons, long long t) {
    std::multiset<long long> avail;
    for (int i = 0; i < nrPersons; i++) {
        avail.insert(0);
    }
    
    int count = 0;
    for (const auto& m : movies) {
        auto it = avail.upper_bound(m.start);
        if (it == avail.begin()) continue; 
        it--; 
        if (*it <= m.start) {
            //cout<<(*it)<<' '<<m.start<<"\n";
            avail.erase(it);
            avail.insert(m.end + t);
            count++;
        }
    }
//    cout<<count<<'\n';
    return count >= K;
}

int get_nr_persons() {
    int pas = 1<<20;
    int rez  = 0;
    while (pas) {
        if (rez + pas <= N && !check(rez + pas, T)) {
            rez += pas;
        }
        pas >>=1;
    }
    rez++;
    return rez;
}

long long get_t_interval(int nrPersons) {
    long long pas = 1LL<<30;
    long long rez  = 0;
    while (pas) {
        if (check(nrPersons, rez + pas)) {
            rez += pas;
        }
        pas >>=1;
    }
    if (rez == (1LL<<31) - 1) {
        return -1;
    }
    return rez;
}


int solve_classic_greedy(vector<Movie> movies, int T) {
    // sort(movies.begin(), movies.end(), [](const Movie &a, const Movie &b) {
    //     return a.end < b.end;
    // });
    int last = 0, max = 0;
    for (int i=0;i<movies.size(); i++) {
        if (movies[i].start >= last) {
            last = movies[i].end + T;
            max ++;
        }
    }
    return max;
}

int main() {
    freopen("cursuri.in", "r", stdin);
    freopen("cursuri.out", "w", stdout);
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    
    cin >> N >> K >> T;
    movies.resize(N);
    for (int i = 0; i < N; i++) {
        cin >> movies[i].start >> movies[i].end;
    }
    
    sort(movies.begin(), movies.end(), [](const Movie &a, const Movie &b) {
        if (a.end == b.end) {
            return a.start < b.start;
        }
        return a.end < b.end;
    });
    
    int persons = get_nr_persons();
    int tInterval = get_t_interval(persons);
    
    // cout<<check(1, T)<<'\n';
    // cout<<solve_classic_greedy(movies, T)<<'\n';

    cout << persons<< " ";
    cout << tInterval<< "\n";
    
    return 0;
}
